;; Problem 34
;; 03 January 2003
;; 145 is a curious number, as 1! + 4! + 5! = 1 + 24 + 120 = 145.
;; Find the sum of all numbers which are equal to the sum of the factorial of their digits.
;; Note: as 1! = 1 and 2! = 2 are not sums they are not included.

;; the way this is stated, the two must diverge, so first we could find how they diverge...

(declaim (inline fact))
(defun fact (n)
  (declare (optimize speed)
	   (type number n))
  (when (= 0 n)
    (return-from fact 1))
   (loop
    for ii from 1 to n
    for ff = ii then (* ff ii)
    finally (return ff)))

;(fact 5)

(defun explode-string (str)
  (loop for ch across str
	collect (format nil "~a" ch)))

(defun explode-string->numbers (str)
  (mapcar #'read-from-string (explode-string str)))

(declaim (inline ch->num))
(defun ch->num (ch)
   (cond ((equal ch #\1) 1)
	 ((equal ch #\2) 2)
	 ((equal ch #\3) 3)
	 ((equal ch #\4) 4)
	 ((equal ch #\5) 5)
	 ((equal ch #\6) 6)
	 ((equal ch #\7) 7)
	 ((equal ch #\8) 8)
	 ((equal ch #\9) 9)
	 ((equal ch #\0) 0)))

(defun fact-sum2 (num)
  (apply #'+ (mapcar #'fact (explode-string->numbers (format nil "~d" num)))))

(defun fact-sum3 (num)
  (apply #'+ (mapcar #'fact (loop for n across (format nil "~d" num)
				  collect (ch->num n)))))

(declaim (inline fact-sum))
(defun fact-sum (num)
  (declare (the number num)
	   (optimize speed))
  (let ((res 0))
    (declare (the number res))
    (loop for n across (format nil "~d" num)
	  do
	  (setf res (+ res (fact (ch->num n)))))
    res))

(assert (= 145 (fact-sum 145)))

;; (time (loop for ii from 1 to 100000
;; 	    do
;; 	    (fact-sum ii)))

;; (time (loop for ii from 1 to 100000
;; 	    do
;; 	    (fact-sum3 ii)))

(declaim (inline is-curious?))
(defun is-curious? (num)
  (= num (fact-sum num)))

(assert (is-curious? 145))
(assert (not (is-curious? 144)))


(loop for ii from 1 to 200
      do
      (format t "ii:~d fact-sum:~d is-curious?:~a~&" ii (fact-sum ii) (is-curious? ii)))

; (explode-string->numbers (format nil "~d" 10))
; (fact-sum 10)

;; fact(9) = 362880
;; so for n 9's, we have (362880 * n), which gives us a max/divergence at 9999999

;; 9999
;; 1451520

;; 99999 
;; 1814400

;; 999999
;; 2177280

;; 9999999
;; 2540160

(defvar *maxval* 9000099)

;(fact-sum 9)       =>  362880
;(fact-sum 9999999) => 2540160
;(fact-sum 9999990) => 2177281
;(fact-sum 9099999) => 2177281
;(fact-sum 9009999) => 1814402
;(fact-sum 9000999) => 1451523
;(fact-sum 9000099) => 1088644

;(fact-sum 9000009) =>  725765
;(fact-sum 999999)  => 2177280 

(time 
 (let ((num-curious 0))
   (loop for ii from 3 to *maxval*
	 do
	 (when (= 0 (mod ii 10000))
	   (format t "at:~d~&" ii))
	 (when (= ii (fact-sum ii))
	   (format t "found: ~a ~a~&"
		   ii
		   (fact-sum ii))
	   (incf num-curious)))
   (format t "num-curious: ~a~&" num-curious)
   num-curious))

; (+ 40585 145)